macroScript Rename_rassian_textures
	category:"# Scripts"
	toolTip:"Rename rassian textures v1.02"
(
	--This script created by Morozov Anton
try (destroyDialog ::Main_rlt) catch()
global f = k = 0
global exitt = false
GLOBAL_INI_FILENAME = "Rename_rassian_textures.ini"
GLOBAL_INI_FILE_PATH = ((getdir #userScripts) + "\\Rename_rassian_textures\\")

--function to save variable to ini file
fn saveVar2IniFile section_name var_name var_value = 
(
	if (getDirectories GLOBAL_INI_FILE_PATH).count == 0 then makeDir GLOBAL_INI_FILE_PATH
	INIFilename = pathConfig.appendPath GLOBAL_INI_FILE_PATH GLOBAL_INI_FILENAME
	setINISetting INIFilename section_name var_name (var_value as string)
)

--function to load variable from ini file
fn loadVarFromIniFile section_name var_name = 
(
	INIFilename = pathConfig.appendPath GLOBAL_INI_FILE_PATH GLOBAL_INI_FILENAME
	temp_value = getINISetting INIFilename section_name var_name
	if temp_value == "" then undefined else temp_value
)

function getAssetFiles = (
	ff_fnd = #()
	ATSOps.CheckNetworkPaths = true
	ATSOps.Refresh()
	ATSOps.GetFiles &ff
	if maxFileName != "" then	deleteItem ff 1
	for i = ff.count to 1 by -1 do (
		if (ATSOps.IsInputFile ff[i]) == false then
			deleteItem ff i
		else (
			ss = ATSOps.GetFileSystemStatus ff[i]
			if  ss[1] == #found do append ff_fnd ff[i]
		)
	)
	#(ff, ff_fnd)
)

function chDir dirpath = (
	if (doesFileExist dirpath) == false then (
		if queryBox("Directory does not exist. Create a Directory?") then
			if (makeDir dirpath all:true) then
				return true
			else messagebox "Can not create directory" title:"Error"
	) else (
		local str = dirpath
		if dirpath.count > 1 do if (substring dirpath (dirpath.count - 1) 2) != ":\\" do str = trimRight dirpath "\\\/"
		if isDirectoryWriteable(str) then
			return true
		else messagebox "Directory not writeable" title:"Error"
	)
	return false
)

function enableCtrl ctrl = (
	if ctrl then 
		for c in Main_rlt.controls where (classof c != ProgressBar) do c.enabled = true
	else
		for c in Main_rlt.controls where (classof c != ProgressBar) do c.enabled = false
)

function chk_path str = (
	str = trimleft str
	str = trimRight str
	str = trimRight str "\\\/"
	str + "\\"
)

rollout Main_rlt "Rename russian textures" width:456 height:159
(
	button open_btn "Select" pos:[358,49] width:82 height:24
	edittext dir_edt "" pos:[10,49] width:335 height:23
	label dir_lbl "Selected Directory to collect renamed files" pos:[16,32] width:328 height:14
	button btn_collect "Rename" pos:[16,84] width:96 height:32
	progressBar pb1 "ProgressBar" pos:[15,135] width:421 height:8
	on Main_rlt open do
	(
			Main_rlt.dir_edt.text = maxFilePath
		)
	on Main_rlt close do
		exitt = true
	on open_btn pressed do
	(
			s = getSavePath caption:"Select Dir" initialDir:Main_rlt.dir_edt.text
			if s != undefined then dir_edt.text = chk_path s
		)
	on dir_edt entered txt do
		dir_edt.text = chk_path dir_edt.text
	on btn_collect pressed do
	(
		enableCtrl false
			if chDir(Main_rlt.dir_edt.text) then (
				russ = ""
				if  (temp_state = loadVarFromIniFile "symbols" "russ") != undefined then
				(
					russ = temp_state as string
				)
				else
				(
					messagebox ("Error load variable russ")
					return()
				)
				enn = ""
				if  (temp_state = loadVarFromIniFile "symbols" "enn") != undefined then
				(
					enn = temp_state as string
				)
				else
				(
					messagebox ("Error load variable enn")
					return()
				)
				ff_npath = #()
				ATSOps.Visible = false
				tt = getAssetFiles(); ff = tt[1]
				ATSOps.SelectFiles tt[2]
				ATSOps.SetPathOnSelection ""
				tt = getAssetFiles(); ff = tt[1]
				newPath = Main_rlt.dir_edt.text
				f = k = 0
				ennsmb = filterString enn ","
				russsmb = filterString russ ","
				for i = 1 to ff.count while not exitt do (
					namefile = getFilenameFile ff[i]
					rusfnd = false
					rename = ""
					fnd = 0
					ss = ATSOps.GetFileSystemStatus ff[i]
					if  (ss[1] == #ok) or (ss[1] == #found) do (
						for j = 1 to namefile.count do (
							fnd = findItem russsmb namefile[j]
							if fnd > 0 then (
								append rename ennsmb[fnd]
								rusfnd = true
							)
							else append rename namefile[j]
						)
					)
					if rusfnd do (
						newfullpath = undefined
						if  (ss[1] == #ok)  do (
							newfullpath = newPath + rename + getFilenameType ff[i]
							oldfullpath = ff[i]
						)
						if  (ss[1] == #found) do (
							ATSOps.GetResolvedPaths ff[i] &resPath
							oldfullpath = resPath[1]
							newfullpath = newPath + rename + getFilenameType ff[i]
						)
						if newfullpath != undefined do (
							while doesFileExist(newfullpath) do newfullpath = getFilenamePath (newfullpath) + getFilenameFile (newfullpath) + "1" + getFilenameType (newfullpath)
								if (copyFile oldfullpath newfullpath) then (
									ATSOps.SelectFiles ff[i]
									ATSOps.RetargetSelection newfullpath
									k = k+1
									print newfullpath
								) else f = f+1
						)
					)
					precents = 1000/(ff.count*10 / i)
					Main_rlt.pb1.value = precents
					if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages() --    
					if exitt then return()
				)
				messagebox ("Copied "+k as string + " files. Errors " + f as string)
				try (destroyDialog ::Main_rlt) catch()
			)
			enableCtrl true
		)
)
ATSOps.Visible = true
createDialog Main_rlt
ATSOps.Visible = false
)

messageBox "rename_russian_textures is now installed!\n\nTo run it goto:\n   Customize -> Customize User Interface -> Toolbars\nCategory: \"# Scripts\" and drag \"rename_russian_textures\" to a toolbar.\n\nClick the toolbar icon to run it!"
